const crypto = require('crypto');

class Encrypt {
    /**
     * encrypt
     * @param {*} content need encrypt content
     * @param {*} key     nonce
     * @returns 
     */
    static encrypt(content, key) {
        var data = content + key;
        // default utf-8
        var base64data = Buffer.from(data).toString('base64');

        const cipherKey = crypto.scryptSync(key, 'salt', 24);
        const iv = Buffer.alloc(16, 0);
        var cipher = crypto.createCipheriv('aes-192-cbc', cipherKey, iv);
        var encrypted = cipher.update(base64data, 'utf8', 'hex');
        encrypted += cipher.final('hex');
        return encrypted;
    }


    /**
     * decrypt
     * @param {*} crypted need crypted content
     * @param {*} key     nonce
     * @returns 
     */
    static decrypt(crypted, key) {
        const decipherKey = crypto.scryptSync(key, 'salt', 24);
        const iv = Buffer.alloc(16, 0);
        var decipher = crypto.createDecipheriv('aes-192-cbc', decipherKey, iv);
        var decrypted = decipher.update(crypted, 'hex', 'utf8');
        decrypted += decipher.final('utf8');

        // default utf-8
        var plainText = Buffer.from(decrypted, 'base64').toString('ascii');

        plainText = plainText.substring(0, plainText.length - key.length);
        return plainText;
    }

    /**
     * simpleEncrypt
     * @param {*} content need encrypt content
     * @returns 
     */
    static simpleEncrypt(content) {
        const cipherKey = crypto.scryptSync('foggiev', 'salt', 24);
        const iv = Buffer.alloc(16, 0);
        var cipher = crypto.createCipheriv('aes-192-cbc', cipherKey, iv);
        var encrypted = cipher.update(content, 'utf8', 'hex');
        encrypted += cipher.final('hex');
        return encrypted;
    }


    /**
     * simpleDecrypt
     * @param {*} crypted need crypted content
     * @returns 
     */
    static simpleDecrypt(crypted) {
        const decipherKey = crypto.scryptSync('foggiev', 'salt', 24);
        const iv = Buffer.alloc(16, 0);
        var decipher = crypto.createDecipheriv('aes-192-cbc', decipherKey, iv);
        var decrypted = decipher.update(crypted, 'hex', 'utf8');
        decrypted += decipher.final('utf8');

        return decrypted;
    }
     /**
    * random genrenate hex string
    * @param {*} length string length 
    * @returns 
    */
    static randomString(length) {
       if (length <= 0) {
           return;
       }
       const result = [];
       const characters = '0123456789abcdef';
       for (let i = 0; i < length; i++) {
           result.push(characters.charAt(Math.floor(Math.random() * characters.length)));
       }
       return result.join('');
   }
}
module.exports = Encrypt